#include <ansi_c.h>
#include <tcpsupp.h>
#include <cvirte.h>		
#include <userint.h>
#include "TCPIPtemp.h"
#include "regexpr.h"

static int alarm_state;
static char temp[100];
static char getmetod[100];
static char *tcp_greska;
static int status_veze;
//static tcpFuncPtr TCP_Callback;
static unsigned int conv_handle=2;
static char ip_adress_str[25];
static char ip_client_adress_str[25];
static int pritisnuto;


static int panelHandle;

int CVICALLBACK TCP_Callback (unsigned handle, int event, int error,
                             void *callbackData);
				  

int main (int argc, char *argv[])
{
	if (InitCVIRTE (0, argv, 0) == 0)
		return -1;	/* out of memory */
	if ((panelHandle = LoadPanel (0, "TCPIPtemp.uir", PANEL)) < 0)
		return -1;
		
	PromptPopup ("Server Name?",
                 "Unesite IP adresu servera "
   				 "\n\n(primer: abc.xyz.com or xxx.xxx.xxx.xxx)",
                 ip_adress_str, 24);
    SetCtrlVal (panelHandle, PANEL_STRING, ip_adress_str); 
	GetTCPHostAddr (ip_client_adress_str, 25);
    SetCtrlVal (panelHandle, PANEL_STRING_2, ip_client_adress_str);
	DisplayPanel (panelHandle);
	RunUserInterface ();
	DiscardPanel (panelHandle);
	return 0;
}

int CVICALLBACK QuitCallback (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	switch (event)
		{
		case EVENT_COMMIT:
			 QuitUserInterface (0);
			break;
		case EVENT_RIGHT_CLICK:

			break;
		}
	return 0;
}

int CVICALLBACK ButtonPush (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	switch (event)
		{
		case EVENT_COMMIT:
			 GetCtrlVal (panelHandle, PANEL_TOGGLEBUTTON, &pritisnuto);
			 
			break;
		case EVENT_VAL_CHANGED:

			break;
		case EVENT_RIGHT_CLICK:

			break;
		}
	return 0;
}

int CVICALLBACK TimerTick (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	switch (event)
		{
		case EVENT_TIMER_TICK:
			if (pritisnuto == 1) {
				  //konektovanje
				 GetTCPHostAddr (temp, 100);
				 //MessagePopup ("Moj IP", temp);  
				 
				 status_veze = ConnectToTCPServer (&conv_handle, 80, ip_adress_str, TCP_Callback, NULL, 1000);
				 if (status_veze < 0) {
				 	//obrada greske
					tcp_greska = GetTCPSystemErrorString ();
					MessagePopup ("Greska", tcp_greska);
				 }
				 else {
					 //konektovani smo
					 //int temp;
					 SetCtrlVal (panelHandle, PANEL_LED, 1);
					 
					 GetCtrlVal (panelHandle, PANEL_BINARYSWITCH, &alarm_state);
					 if (alarm_state==1) strcpy(getmetod,"1");
					 else strcpy(getmetod,"0");
					 
					 //sprintf(getmetod,"x");	// prenos stranice se zapocinje slanjem bilo cega, 
					 						//ne mora GET zahtev TCP /index.html HTTP/1.0		
					 ClientTCPWrite (conv_handle, getmetod, strlen(getmetod), 1000);
					// temp += 100;
				 }
			 }
			break;
		}
	return 0;
}

int CVICALLBACK TCP_Callback (unsigned handle, int event, int error,
                             void *callbackData)
{
	char text_to_find[10]="tempAD10=";
	char *temp_string=NULL;
	char temp_value[10]="";
	int int_temp_val;
	int i;
	
	char* data = NULL;
	int MAXBYTES = 15000;
	int bytes_read;
	data = malloc(MAXBYTES*sizeof(char));
	if (data==NULL) return -1;
	


    switch (event)
        {
        case TCP_DATAREADY:
			bytes_read = ClientTCPRead (conv_handle, data, MAXBYTES-1, 0);
        	if (bytes_read <= 0) {
        	   //jbg
        	   goto Down;
        	}
        	else {
        		//cool
        		data[bytes_read]='\0';
        	//	MessagePopup ("Info", data);   
        	}
        	
        	
        	temp_string=strstr(data,text_to_find);
			if (temp_string == NULL) break;
        	temp_string=&temp_string[strlen(text_to_find)];
        	for(i=0;i<4;i++)
					{
						if (temp_string[i]=='%') break;
					}

			strncat(temp_value,temp_string,i);
			int_temp_val=atoi(temp_value);
			int_temp_val=int_temp_val/2;
//			MessagePopup ("vrednost temperature", temp_value);
			SetCtrlVal (panelHandle, PANEL_NUMERICTHERM, int_temp_val);
   


            break;
        case TCP_DISCONNECT:
			DisconnectFromTCPServer (conv_handle);
			SetCtrlVal (panelHandle, PANEL_LED, 0); 

            break;
    }
Down:    
    free(data);
    return 0;
}




